Subject: bug#37189: 25.4.1: vc-hg-ignore implementation is missing

From: Dmitry Gutov <[email-masked]>
Date: Sun, 23 Feb 2020 01:58:33 +0200

On 23.02.2020 0:00, Wolfgang Scherer wrote:

>> Escaping/anchoring can be added in the next step of the "series of ad-hoc patches".
> I'm not saying to implement it now, I am just describing use cases, which are not limited to Emacs 27.

Sure.

>>> RCS, SCCS do not have ignore files, so they should error out. SRC has
>>> ignore files similar to CVS and SVN.
>>
>> They will fail anyway because they implement neither 'find-ignore-file' nor the 'ignore' backend actions.
> This is in reference to the condition-case around find-ignore-file, which is not necessary. It is OK to error out in that case.

Without it, SVN and CVS would fail as well (since they don't implement 
'find-ignore-file').

>> I think the patch is compatible with those. At least with the SVN one (vc-cvs-ignore might need a little work).
>>
>> Have you tried this patch with SVN? Is there a particular scenario where it fails?
> No, it should not. CVS is now also patched, so it will no longer fail.

Cool. Thank you. I have now pushed the patch to emacs-27.

Please let us know if you see any unexpected problems.

>>> I apologize for introducing ewoc into vc-dir-mode. Meanwhile I have
>>> discovered vc-deduce-fileset, which does all the hard work for
>>> preparing a fileset in vc-dir-mode, dired-mode and other
>>> modes. vc-deduce-fileset delivers a backend and absolute file names,
>>> not relative file names.
>>
>> Please submit a patch fixing that whenever you have the time.
> I don't think it should be done before Emacs 28.

It's fine to submit bug reports and patches now already. We can even 
install them on master.

>>> I think introducing relative file names in
>>> function APIs is the wrong way to go. However, as a preliminary
>>> solution, it does suffice.
>>
>> I think it's just fine if the function is supposed to receive an *ignore pattern*, and not a simple file name.
> 
> Again, it is probably not the time right now to discuss these matters.
> 
> What will be the time frame for starting Emacs 28 topics?

Since the discussion of vc-ignore in Emacs 27 seems finished, we can go 
on ahead with that right now.